Lparameters oFoxcode

#define test .f.

* -    Set Step On
#Define true    .T.
#Define false    .F.
#Define IsTrue = true
#Define IsFalse = false
#Define SetTrue  Store true To
#Define SetFalse Store false To
#Define IsPrivateVariable IsTrue

#if test
    Set Step On 
    m.oFoxcode = CreateObject("empty")
    AddProperty(m.oFoxcode,"valuetype")
    AddProperty(m.oFoxcode,"fullline","ls")

#endif



oFoxcode.valuetype = "V"

#Define C_ALLDATABASETYPTE_VFP  ;
    "a;array,b;double,c;character,d;date,f;float,g;general,i;integer,l;logical,m;memo,n;numeric,"+ ;
    "o;object,q;varbinary,s;string,t;datetime,u;undefine,w;blod,y;currency"
    



#Define C_TYPE_ATTENDUE "Le type de la variable n'est pas le bon :"

* -    Set Debug On
* -    Set Step On

* -------------------------------------------------------------------------------- 
Local lcAbrev  As String
lcAbrev = Alltrim(m.oFoxcode.fullline)

Local Success As logical
m.Success = .T.


Private lcEtendue
m.lcEtendue =""
Set Safety Off
* - StrToFile("Ligne=
*Debugout "ligne 45" , m.lcEtendue



Local lcTypeName  As String

Local lo As Session

lo = Createobject("uneSession",@lcAbrev,@Success)

Local lcAffectation As String
Local lcTitre As String
Local lcCaption As String
Local lcVarNom As String
Local lcChr As String
Local lcListChr  As String
Local lcRetour  As String


m.lcRetour = ""

If Success

    m.lcEtendue  = Proper(lo.cEtendue)
    m.lcTypeName = lo.cTypeName

    m.lcTitre = "nom de la variable et sont affectation : "+m.lcAbrev+"MaVar=.t."
    m.lcCaption = "Etendue : "+ m.lcEtendue

    m.lcAffectation = ""

    * --------------------------------------------------------------------------------
    If m.lcEtendue=="Private"

        m.lcAbrev = Left(m.lcAbrev ,1)+ "_" + Right(m.lcAbrev ,1)

    Endif && m.lcEtendue=="Private"

    * --------------------------------------------------------------------------------

    m.lcAffectation = EMInputbox( m.lcTitre , m.lcCaption ,m.lcAbrev , @Success )

    * --------------------------------------------------------------------------------
    If Success IsTrue

        lcListChr = "abcdefghijklmnopqrstuvwxyz_0123456789"

        m.lcVarNom = ""

        * --------------------------------------------------------------------------------
        For i = 1 To Len(m.lcAffectation)
            lcChr = Substr(m.lcAffectation,i,1)

            * --------------------------------------------------------------------------------
            * --------------------------------------------------------------------------------
            If Lower(lcChr) $ m.lcListChr

                m.lcVarNom = m.lcVarNom + lcChr

            Else

                Exit

            Endif
            * --------------------------------------------------------------------------------
            * --------------------------------------------------------------------------------

        Endfor
        * --------------------------------------------------------------------------------

 
        If m.lcEtendue=="Private"

            lcRetour = m.lcEtendue+" "+m.lcVarNom+" &"+"& as" + m.lcTypeName +Chr(13)+m.lcAffectation

        Else

            lcRetour = m.lcEtendue+" "+m.lcVarNom+" as "+ m.lcTypeName +Chr(13)+m.lcAffectation
        Endif

        * -        TEXT TO m.lcRetour NOSHOW TEXTMERGE  && additive
        * -           <<m.lcEtendue>> <<m.lcVarNom>> as <<m.lcTypeName>>
        * -           m.<<m.lcAffectation>>

        * -        ENDTEXT
    Else
        m.lcr
    Endif

Endif

Return m.lcRetour
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------



*  / EmInputBox
* / Eddy Maue a+  --   Crer le : 2018-09-03
* ----------------------------------------------------------------------------------------
* Wait Window EmInputBox("Exemple : MaVariable = 5","Local as string",'ll' , @success)

Procedure EMInputbox
    Lparameters  tcTitre,tcCaption, tcDefaultValue , Success

    Private gcRetVal,glSuccess
    m.gcRetVal = ""
    glSuccess = Success

    Local loFrm As Form
    loFrm = Createobject("clssEMInputBox",tcTitre,tcCaption, tcDefaultValue)
    loFrm.Show(1)

    Success= glSuccess
    Return gcRetVal
Endproc && EmInputBox

* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
Define Class uneSession As Session
    cTypeName = ""
    lSuccess  = .T.
    oColectionTypeName = .Null.
    cEtendue = ""



    * --------------------------------------------------------------------------------
    * --------------------------------------------------------&& uneSession:init
    Procedure Init ( tcAbrev , Success )

        With This As Session

            .lSuccess = m.Success

            .oColectionTypeName = Createobject("clssColectionBaseType")

            Do Case

                Case Success IsFalse

                Case Type(".oColectionTypeName")=="O" IsFalse

                    Assert .F.
                    SetFalse Success
                Case .mFillCollection(C_ALLDATABASETYPTE_VFP) IsFalse

                    Assert .F.
                    SetFalse Success
                Case .mGetTypeName(tcAbrev) IsFalse

                    Assert .F.
                    SetFalse Success
                Case .mGetEtendue(tcAbrev)IsFalse
                    Assert .F.
                    SetFalse Success

                Otherwise

            Endcase


        Endwith && this as Session

        Return Success

    Endproc && uneSession:init

    *  / mGetEtendue
    * / Eddy Maue a+  --   Crer le : 2018-09-01
    Procedure mGetEtendue(tcAbrev)

        Local Success As logical
        m.Success = .T.

        Assert Vartype(m.tcAbrev)=="C" Message "m.lcAbrev n'est pas une chaine de caracteres"

        Local lcAbrev As String
        m.lcAbrev = Alltrim( tcAbrev )

        * vrifier la port de la variable
        * l = Local
        * p = public  : tendue  l'application
        * g = private : etendue aux sous-mthodes appeles

        *Local lcEtendue && Port ;o)
        m.lcEtendue = Lower(Left(m.lcAbrev ,1 ))

        Do Case

            Case Success IsFalse

            Case m.lcEtendue = "p"
                m.lcEtendue = "Public"
            Case m.lcEtendue = "l"
                m.lcEtendue = "Local"
            Case m.lcEtendue = "g"
                m.lcEtendue = "Private"


            Otherwise

                Assert .F. Message " la port de la variable n'est pas bien identifie : P L ou G est attendue"
                Success IsFalse
        Endcase

        If Success

            This.cEtendue = m.lcEtendue

        Endif

        Return Success

    Endproc && mGetEtendue

    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    Procedure mGetTypeName(tcAbrev)

        Assert Vartype(m.tcAbrev)=="C" Message C_TYPE_ATTENDUE + [m.tcAbrev)=='C' et non ]+ Vartype(m.tcAbrev)


        Local Success As logical
        m.Success = .T.

        Local loColBaseType As Collection
        m.loColBaseType = m.this.oColectionTypeName


        Local lcAbrev
        m.lcAbrev =Right( Alltrim(m.tcAbrev) ,1)

        Local lcType As String
        m.lcType = ""


        Do Case

            Case Success IsFalse

            Case Len(m.lcAbrev) = 1

                m.lcType = m.loColBaseType(m.lcAbrev)


            Otherwise
                SetFalse Success
        Endcase

        If Success
            This.cTypeName = m.lcType
        Endif

        Return Success


    Endproc



    *  / mFillCollection
    * / Eddy Maue a+  --   Crer le : 2018-09-01
    Procedure mFillCollection( tcData As String )


        Local Success As logical
        m.Success = .T.

        Assert Vartype(m.tcData)=="C" Message C_TYPE_ATTENDUE +[Vartype(m.tcData)=="C" et non ]+  "'"+Vartype(m.tcData)=="C"+"'"

        Local lcBaseType
        m.lcBaseType = tcData

        Local Array laBaseType(1)
        Local lnBaseType
        m.lnBaseType = 0

        Local lcAbrevBasetype
        m.lcAbrevBasetype = ""

        Local lcNameBasetype
        m.lcNameBasetype = ""

        m.lnBaseType = Alines(laBaseType , m.lcBaseType , 1 , ",")

        Assert m.lnBaseType>0 Message "m.lnBaseType doit etre +> 0 ???"


        Do Case

            Case Success IsFalse

            Case m.lnBaseType > 0
                * --------------------------------------------------------------------------------
                With This.oColectionTypeName As Collection
                    For ni = 1 To m.lnBaseType

                        m.lcNameBasetype = Getwordnum(laBaseType(ni),2,";")
                        m.lcAbrevBasetype = Getwordnum(laBaseType(ni),1,";")

                        * ajout  la collection
                        *
                        .Add( m.lcNameBasetype,m.lcAbrevBasetype)

                    Endfor
                Endwith

            Otherwise
                SetFalse Success
        Endcase

        Return Success

    Endproc && mFillCollection



Enddefine
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------






* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
Define Class clssColectionBaseType As clssColectionType

    cBaseType = ""
    KeySort = 2

    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    *  / init
    * / Eddy Maue a+  --   Crer le : 2018-08-26
    Procedure Init(tcData)  && clssColectionBaseType:init
        * -            This.cBaseType = C_ALLDATABASETYPTE_VFP

        * -            Local Success As logical
        * -            m.Success = .T.

        * -


        * -            * --------------------------------------------------------------------------------
        * -            Do Case

        * -                Case Success IsFalse

        * -                Case This.mfillcolection() IsFalse

        * -                Otherwise

        * -            Endcase
        * -            * --------------------------------------------------------------------------------

    Endproc && clssColectionBaseType:init





    *  / mFillCollection
    * / Eddy Maue a+  --   Crer le : 2018-08-31
    Procedure mfillcolection(tcData)

        * -            Local Success As logical
        * -            m.Success = .T.

        * -            Local lcBaseType
        * -            m.lcBaseType = This.cBaseType

        * -            Local Array laBaseType(1)
        * -            Local lnBaseType
        * -            m.lnBaseType = 0

        * -            Local lcAbrevBasetype
        * -            m.lcAbrevBasetype = ""

        * -            Local lcNameBasetype
        * -            m.lcNameBasetype = ""

        * -            m.lnBaseType = Alines(laBaseType , m.lcBaseType , 1 , ",")

        * -            Assert m.lnBaseType>0 Message "m.lnBaseType doit etre +> 0 ???"


        * -            Do Case

        * -                Case Success IsFalse

        * -                Case Vartype( tcData ) == "L"
        * -                    * --------------------------------------------------------------------------------
        * -                    With This As Collection
        * -                        For ni = 1 To m.lnBaseType

        * -                            m.lcNameBasetype = Getwordnum(laBaseType(ni),2,";")
        * -                            m.lcAbrevBasetype = Getwordnum(laBaseType(ni),1,";")

        * -                            * ajout  la collection
        * -                            *
        * -                            .Add( m.lcNameBasetype,m.lcAbrevBasetype)

        * -                        Endfor
        * -                    Endwith

        * -                Otherwise
        * -                    SetFalse Success
        * -            Endcase

        * -            Return Success


    Endproc && mFillCollection



Enddefine  && clssColectionBaseType as clssColectionType
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------



* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
Define Class clssColectionType As Collection

    Procedure Init


    Endproc && init

Enddefine
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------

* -    *  / EmInputBox
* -    * / Eddy Maue a+  --   Crer le : 2018-09-03
* -    * --------------------------------------------------------------------------------
* -    * EmInputBox("Exemple : MaVariable = 5","Local as string",'ll')
* -    * --------------------------------------------------------------------------------
* -    Procedure EmInputBox
* -        Lparameters  tcTitre,tcCaption, tcDefaultValue

* -        Private gcRetVal
* -        m.gcRetVal = ""
* -
* -        Local loFrm As Form
* -        loFrm = Createobject("clssEMInputBox",tcTitre,tcCaption, tcDefaultValue)
* -        loFrm.Show(1)

* -        Return gcRetVal
* -    Endproc && EmInputBox





**************************************************
*-- Auteur     :  Eddy Maue
*-- Form:         form1 (c:\vfp\dev\test_EmInputBox.scx)
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   09/02/18 06:36:02 PM
*

Define Class clssEMInputBox As Form

    AutoCenter= .T.
    WindowType= 1 && modal
    Top = -1
    Left = 0
    Height = 108
    Width = 289
    DoCreate = .T.
    Caption = "EmInputBox : cDialogCaption"
    cTitre = ""
    cCaption = ""
    cRetvalue = ""
    Name = "Form1"
    Success = .T.

    * --------------------------------------------------------------------------------
    Add Object lblPromptInput As Label With ;
        AutoSize = .T., ;
        Caption = "cInputPrompt ", ;
        Height = 17, ;
        Left = 5, ;
        Top = 12, ;
        Width = 78, ;
        Name = "lblPromptInput "

    * --------------------------------------------------------------------------------
    Add Object btnAccept As CommandButton With ;
        Top = 72, ;
        Left = 107, ;
        Height = 27, ;
        Width = 84, ;
        Anchor = 12, ;
        Caption = "Accepter", ;
        Default = .T., ;
        Name = "btnAccept"


    * --------------------------------------------------------------------------------
    Add Object btnAnnuler As CommandButton With ;
        Top = 72, ;
        Left = 197, ;
        Height = 27, ;
        Width = 84, ;
        Anchor = 12, ;
        Cancel = .T., ;
        Caption = "Annuler", ;
        Name = "btnAnnuler"


    * --------------------------------------------------------------------------------
    Add Object edit1 As EditBox With ;
        Anchor = 15, ;
        Height = 24, ;
        Left = 5, ;
        ScrollBars = 0, ;
        Top = 36, ;
        Width = 276, ;
        Name = "Edit1"

    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    Procedure ccaption_assign
        Lparameters tcCaption

        Store m.tcCaption To This.cCaption, This.Caption
    Endproc


    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    Procedure ctitre_assign
        Lparameters tcTitre
        This.cTitre = tcTitre
        This.label1.Caption = tcTitre
    Endproc


    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    Procedure mAccept
        Thisform.cRetvalue = Thisform.edit1.Text
        Thisform.Release()
    Endproc

    Procedure Release
        m.gcRetVal = This.cRetvalue
        m.glSuccess = This.Success
    Endproc

    Procedure Unload
    Endproc


    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    * --------------------------------------------------------------------------------
    Procedure Init
        Lparameters  tcTitre,tcCaption, tcDefaultValue

        Local lsDefault As String
        lsDefault = Transform(m.tcDefaultValue)

        If Vartype(m.tcCaption)=="C" And Not Empty(m.tcCaption)
            This.Caption = m.tcCaption
        Endif

        If Vartype(m.tcTitre)=="C" And Not Empty(m.tcTitre)
            This.lblPromptInput.Caption = m.tcTitre
        Endif

        If Vartype(m.lsDefault)=="C" And Not Empty(m.lsDefault)
            This.edit1.Value = m.lsDefault
        Endif

        This.edit1.SetFocus()
        This.edit1.SelStart = 3000
    Endproc


    Procedure mAnnuler()

        Thisform.QueryUnload()

    Endproc


    Procedure btnAccept.Click
        Thisform.mAccept()
    Endproc


    Procedure btnAnnuler.Click()
        Thisform.mAnnuler()
    Endproc

    Procedure QueryUnload()
        This.Success = .F.
        Thisform.cRetvalue = ""
        Thisform.Release
    Endproc



Enddefine
*
*-- EndDefine: form1
**************************************************

