
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --- Eddy Maue
* --- Cre le : 2018-09-03
* --- libre de droit avec une restriction
* --- -     que cette entte demeure
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------

#Define C_ALLDATABASETYPTE_VFP  ;
    "a;array,b;double,c;character,d;date,f;float,g;general,i;integer,l;logical,m;memo,n;numeric,"+ ;
    "o;object,q;varbinary,s;string,t;datetime,u;undefine,w;blod,y;currency"

Set Step On
Local  lcAbbrev,  ltTimesTamp, lcUniqueID

Local loFoxcodeField As Empty
m.loFoxcodeField = Createobject("empty")

AddProperty(m.loFoxcodeField ,"Type"     , "C" )
AddProperty(m.loFoxcodeField ,"Cmd"      , [{DeclareVar}] )
AddProperty(m.loFoxcodeField ,"Case"     , "M" )

* champs qui vont voluer en cours d'insertions
AddProperty(m.loFoxcodeField ,"Abbrev"   , "la" )
AddProperty(m.loFoxcodeField ,"Timestamp", Datetime() )
AddProperty(m.loFoxcodeField ,"Uniqueid" , Sys(2015) )

Local Array laDecVarType(1)

Local lnLine As Integer
lnLine = Alines(laDecVarType, C_ALLDATABASETYPTE_VFP ,1+4+8 ,",")

Local tabEtendue(3)

Local lsFoxcode as string
lsFoxcode = _foxcode 

Local lsFoxCodeTbl as string
lsFoxCodeTbl = JustStem(m.lsFoxcode)

If not Used(m.lsFoxCodeTbl)
    Use (m.lsFoxcode) In 0
endif
Select (m.lsFoxCodeTbl)

m.tabEtendue(1) = "l"  && local
m.tabEtendue(2) = "p"  && publique
m.tabEtendue(3) = "g"  && global ou priv

m.lcUniqueID = Sys(2015)
m.ltTimesTamp = Datetime()
For i = 1 To m.lnLine
    For j = 1 To 3

        m.lcAbbrev =Padr( m.tabEtendue(j) + Getwordnum(m.laDecVarType(i),1,";")  ,Fsize('abbrev'),Space(1))

        Locate For Lower(abbrev) == m.lcAbbrev

        If Found()
            Loop
        Endif

        m.ltTimesTamp = Datetime()

        * je m'assure que m.lcUniqueID est unique
        Do While m.lcUniqueID == Sys(2015)
            DoEvents
        Enddo

        m.lcUniqueID = Sys(2015)

        m.loFoxcodeField.abbrev = m.lcAbbrev
        m.loFoxcodeField.Timestamp = m.ltTimesTamp
        m.loFoxcodeField.uniqueid = m.lcUniqueID

        * -    Insert into (_foxcode ) type, abbrev, cmd, case timestamp, ;
        * -        VALUES ("C" , lcAbbrev ,"" , [{DeclareVar}] ,"M"

        Insert Into Foxcode From Name m.loFoxcodeField


    Endfor
Endfor
